@REM ############################################################ {COPYRIGHT-TOP} ###
@REM # IBM Confidential
@REM # OCO Source Materials
@REM # Tivoli Common Reporting Infrastructure
@REM # 5724-T69
@REM #
@REM # Copyright IBM Corp. 2011
@REM #
@REM # The source code for this program is not published or otherwise
@REM # divested of its trade secrets, irrespective of what has been
@REM # deposited with the U.S. Copyright Office.
@REM ############################################################ {COPYRIGHT-END} ##
@echo off

set DEFAULT_INSTALLATION_DIR=C:\IBM\tivoli\tcr21base\tipv2Components\TCRComponent
setlocal
set PATH=%SystemRoot%\System32;%SystemRoot%;%SystemRoot%\system32\wbem;%PATH%
set LOGFILE=%temp%\IBM_Tivoli_Common_Reporting_2.1.1.2_IF3.log
set ERROR=0

echo ----------------------------------------------------------------
echo IBM Tivoli Common Reporting 2.1.1.2 IF3
echo ----------------------------------------------------------------

if "%1" == "-i" set DO=update
if "%1" == "-r" set DO=undo
set TCRCOMP_HOME=%2
if "%DO%" == "" (
   call :USAGE
   set ERROR=1
   goto :END
)
if ""%TCRCOMP_HOME%"" == "" (
   call :USAGE
   set ERROR=1
   goto :END
)
set TIP_HOME=


cd %TCRCOMP_HOME%\integration\properties
For /F "tokens=1* delims==" %%A IN (tcr.properties) DO (  IF "%%A"=="TIP_HOME" set TIP_HOME=%%B   )
pushd %TCRCOMP_HOME%
popd

set TIP_HOME=%TIP_HOME%\bin
set TIP_HOME=%TIP_HOME:\:=:%
set TIP_HOME=%TIP_HOME:\\=\%
set TIP_HOME=%TIP_HOME:   \=\%
set TIP_HOME=%TIP_HOME:  \=\%
set TIP_HOME=%TIP_HOME: \=\%
@REM #######################################################################
@REM ### %ProgramFiles% serves for all flavours of OS paths used for DE installations ###
@REM #######################################################################
@echo Setting up Deployment Engine environment.
set ProgRoot=%ProgramFiles%
if not "%ProgramFiles(x86)%" == "" set ProgRoot=%ProgramFiles(x86)%
call "%ProgRoot%\IBM\Common\acsi\setenv.cmd"
@echo off
for /f "tokens=1*" %%i in ('sc query state^= all ^| find "IBMWAS70Service"') do (   
   for /f "tokens=*" %%k in ('sc qc "%%j" ^| find "%TIP_HOME%\wasservice.exe"') do (   
     sc query "%%j" | find "RUNNING" 1>nul 2>&1
      if NOT ERRORLEVEL 1 (
         if "%DO%" == "update" (
            @echo Stop Tivoli Common Reporting server before installing InterimFix.
         ) else (
            @echo Stop Tivoli Common Reporting server before uninstalling InterimFix.
         )
         goto :END
      )
   )
)

if "%DO%" == "update" (
   set OPTIONS=-u true
   @echo Installing TCR-2112-IF3...It will take more time, please wait..
) else (
   @echo Uninstalling TCR-2112-IF3...It will take more time, please wait..
)
pushd %~dp0\TCR-2112-0003\META-INF
call manageIU.bat -o %DO% -r %TCRCOMP_HOME% -p packagedIU.xml %OPTIONS% 1>>"%LOGFILE%" 2>&1

if ERRORLEVEL 1 (
   if "%DO%" == "update" (
      @echo TCR2112 IF3 installation failed.
   ) else (
      @echo TCR2112 IF3 uninstallation failed.
   )
   @echo Check details in %LOGFILE%
   set ERROR=3
   goto :END
)
popd

if %ERROR% == 0 (
   if "%DO%" == "update" (
      @echo TCR2112 IF3 installed successfully.
   ) else (
      @echo TCR2112 IF3 uninstalled successfully.
   )
   @echo Now start Tivoli Common Reporting server.
)

:END
   endlocal
   exit /b %ERROR%

:USAGE
   echo Usage:  %~n0 -i ^| -r [TCR_INSTALLATION_DIR]
   echo.
   echo where:
   echo   -i        Install TCR2112 IF3.
   echo   -r        Rollback (uninstall) TCR2112 IF3.
   echo   [TCR_INSTALLATION_DIR] (example: %DEFAULT_INSTALLATION_DIR%)
   echo.
